<i18n>
{
  "fr": {
    "label-1": "Véhicules du laboratoire",
    "label-2": "Emissions incertitude",
    "label-3": "incertitude",
    "label-4": "Part de l'empreinte totale",
    "wcontrails": "Avion (avec trainées)"
  },
  "en": {
    "label-1": "Vehicles of the laboratory",
    "label-2": "Emissions uncertainty",
    "label-3": "Uncertainty",
    "label-4": "Share of the total footprint",
    "wcontrails": "Plane (with contrails)"
  }
}
</i18n>

<template>
  <div>
    <b-tabs class="block">
      <b-tab-item icon="bar-chart" :label="$t('emissions.t.co2e.short')">
        <br />
        <highcharts :options="DProEmissionOptions"></highcharts>
        <br />
        <b-table
          :striped="true"
          :narrowed="true"
          :hoverable="true"
          :data="dProEmission"
          :columns="columnsEmission"
        />
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('distances.km')" v-if="travels.total!==0">
        <br />
        <highcharts :options="DProDistanceOptions"></highcharts>
        <br />
        <b-table
          :striped="true"
          :narrowed="true"
          :hoverable="true"
          :data="dProDistance"
          :columns="columnsDistance"
        />
      </b-tab-item>
    </b-tabs>
  </div>
</template>

<script>
import Travel from '@/models/carbon/Travel.js'
import '@/plugins/highcharts.js'

export default {
  name: 'PlotsAllTravels',
  props: {
    withContrails: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      DProEmissioni: [],
      total: 0,
      distanceTotal: 0,
      DProEmissionOptions: {
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        series: [
          {
            type: 'column',
            data: [],
            showInLegend: false,
            tooltip: {
              pointFormat: '<b>{point.y} ' + this.$t('t.co2e') + '</b>',
              valueDecimals: 2
            }
          }, {
            name: this.$t('label-2'),
            type: 'errorbar',
            lineWidth: 2,
            data: [],
            tooltip: {
              pointFormat: ' (' + this.$t('label-3') + ': {point.low} - {point.high} ' + this.$t('t.co2e') + ')<br/>',
              valueDecimals: 2
            }
          }
        ],
        xAxis: {
          categories: [],
          crosshair: true
        },
        yAxis: {
          min: 0,
          title: {
            text: this.$t('emissions.t.co2e.short')
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        tooltip: {
          shared: true
        }
      },
      DProDistanceOptions: {
        chart: {
          type: 'column'
        },
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        series: [
          {
            showInLegend: false,
            data: []
          }
        ],
        xAxis: {
          categories: [],
          crosshair: true
        },
        yAxis: {
          min: 0,
          title: {
            text: this.$t('distances.km')
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        tooltip: {
          pointFormat: '<b>{point.y} km</b>',
          valueDecimals: 0
        }
      }
    }
  },
  computed: {
    travels: function () {
      return this.$store.getters['travels/results']
    },
    vehicles: function () {
      return this.$store.getters['vehicles/results']
    },
    dProEmission: function () {
      let i = 0
      let obj = { 'label': '<nobr>' + this.$t('emissions.t.co2e.short') + '</nobr>' }
      let objp = { 'label': '<nobr>' + this.$t('label-4') + '</nobr>' }
      for (let category of this.DProEmissionOptions.xAxis.categories) {
        obj[category] = '<nobr>' + this.DProEmissionOptions.series[0].data[i].toFixed(2) + ' +/- ' + this.DProEmissioni[i].toFixed(2) + '</nobr>'
        objp[category] = (this.DProEmissionOptions.series[0].data[i] / this.total * 100).toFixed(2) + ' %'
        i += 1
      }
      return [obj, objp]
    },
    dProDistance: function () {
      let i = 0
      let obj = { 'label': '<nobr>' + this.$t('distances.km') + '</nobr>' }
      let objp = { 'label': '<nobr>' + this.$t('label-4') + '</nobr>' }
      for (let category of this.DProDistanceOptions.xAxis.categories) {
        obj[category] = this.$options.filters.splitNumber(this.DProDistanceOptions.series[0].data[i])
        objp[category] = (this.DProDistanceOptions.series[0].data[i] / this.distanceTotal * 100).toFixed(2) + ' %'
        i += 1
      }
      return [obj, objp]
    },
    columnsEmission: function () {
      let columns = [{
        'field': 'label',
        'label': '',
        'sticky': true
      }]
      for (let mode of this.DProEmissionOptions.xAxis.categories) {
        columns.push({
          'field': mode,
          'label': this.$t(mode),
          'numeric': true
        })
      }
      return columns
    },
    columnsDistance: function () {
      let columns = [{
        'field': 'label',
        'label': '',
        'sticky': true
      }]
      for (let mode of this.DProDistanceOptions.xAxis.categories) {
        columns.push({
          'field': mode,
          'label': this.$t(mode),
          'numeric': true
        })
      }
      return columns
    }
  },
  methods: {
    processMissions: function () {
      if (this.$store.getters['travels/hasItems']) {
        let i = 0
        for (let cat of Travel.transportations) {
          if (this.withContrails) {
            this.DProEmissionOptions.xAxis.categories.push(this.$t(cat))
            this.DProEmissionOptions.series[0].data.push(this.travels.transportations.intensity[i].intensitywc / 1000)
            let iTab = [this.travels.transportations.intensity[i].intensitywc / 1000 - this.travels.transportations.intensity[i].uncertaintywc / 1000, this.travels.transportations.intensity[i].intensitywc / 1000 + this.travels.transportations.intensity[i].uncertaintywc / 1000]
            this.DProEmissionOptions.series[1].data.push(iTab)
            this.DProEmissioni.push(this.travels.transportations.intensity[i].uncertaintywc / 1000)
            this.total += this.travels.transportations.intensity[i].intensitywc / 1000
          } else {
            this.DProEmissionOptions.xAxis.categories.push(this.$t(cat))
            this.DProEmissionOptions.series[0].data.push(this.travels.transportations.intensity[i].intensity / 1000)
            let iTab = [this.travels.transportations.intensity[i].intensity / 1000 - this.travels.transportations.intensity[i].uncertainty / 1000, this.travels.transportations.intensity[i].intensity / 1000 + this.travels.transportations.intensity[i].uncertainty / 1000]
            this.DProEmissionOptions.series[1].data.push(iTab)
            this.DProEmissioni.push(this.travels.transportations.intensity[i].uncertainty / 1000)
            this.total += this.travels.transportations.intensity[i].intensity / 1000
          }
          this.DProDistanceOptions.xAxis.categories.push(this.$t(cat))
          this.DProDistanceOptions.series[0].data.push(this.travels.transportations.distances[i])
          this.distanceTotal += this.travels.transportations.distances[i]
          i += 1
        }
      }
    },
    processVehicles: function () {
      if (this.$store.getters['vehicles/hasItems']) {
        if (!this.DProEmissionOptions.xAxis.categories.includes(this.$t('label-1'))) {
          this.DProEmissionOptions.xAxis.categories.push(this.$t('label-1'))
          this.DProEmissionOptions.series[0].data.push(this.vehicles.intensity.intensity / 1000)
          let iTab = [this.vehicles.intensity.intensity / 1000 - this.vehicles.intensity.uncertainty / 1000, this.vehicles.intensity.intensity / 1000 + this.vehicles.intensity.uncertainty / 1000]
          this.DProEmissionOptions.series[1].data.push(iTab)
          this.DProEmissioni.push(this.vehicles.intensity.uncertainty / 1000)
          this.total += this.vehicles.intensity.intensity / 1000
        }
      }
    }
  },
  mounted () {
    if (!this.$store.getters['travels/computed']) {
      this.$store.dispatch('travels/compute')
    }
    if (!this.$store.getters['vehicles/computed']) {
      this.$store.dispatch('vehicles/compute')
    }
    this.processMissions()
    this.processVehicles()
  }
}
</script>

<style>
.is-sticky {
  background: #fafafa !important;
}
.table td {
  vertical-align: middle !important;
}
</style>
